var timeout = 3.0;	// sec
var timerID;
var interval = 1*60*1000;	// ms
var scanButton;
var scanners = new Array;

var hosts = new Array();

//ヒックリ返し関連
var gDoneButton;
var gInfoButton;

function init()
{
	//ひっくり返し系
	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
	
	if (window.widget) {
		widget.onshow = onShow;
		widget.onhide = onHide;
	}
	/* そのうちHost[]で全部処理できるようにしたいなぁと思ってるんですが…どうでしょ。
	var i;
	var lis = document.getElementById("hosts").getElementsByTagName("li");
	for(i = 0; i < lis.length; i++)
		scanners.push(new Scanner(i));
	LOG__("scanners.length:" + scanners.length);
	*/
	var hostStrings = Widget.preferenceArrayForKey("hosts");
	for( i in hostStrings )
		addHost(createHostFromHostString(hostStrings[i]));
	
	scanButton = new AppleGlassButton(document.getElementById("scanButton"), "Scan", scan);

	setTimeout("scan()", 100);
	timerID = setInterval("scan()", interval);
}

function onShow() {
	clearInterval(timerID);
	scan();
	timerID = setInterval("scan()", interval);
}

function onHide() {
	clearInterval(timerID);
}

function showPrefs(){
	clearInterval(timerID);
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs(){
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	
	//ホストを記憶
	if(window.widget){
		var hostStrs = new Array(hosts.length);
		for( i in hosts)
			hostStrs[i] = hosts[i].toString();
		
		Widget.setPreferenceArrayForKey(hostStrs, "hosts");
		LOG__(Widget.preferenceArrayForKey("hosts").toString());
	}
	
	clearInterval(timerID);
	scan();
	timerID = setInterval("scan()", interval);
}

function scan()
{
	var i;
	for(i = 0; i < scanners.length; i++)
		scanners[i].start();
}

function Scanner(myNumber) {
	LOG__("Object: Scanner");
	var i;
	var lis = document.getElementById("hosts").getElementsByTagName("li");
	var li = lis[myNumber];
	var spans = li.getElementsByTagName("span");

	this.li = li;
	for (i=0; i < spans.length; i++) {
		if (spans[i].className == "hostIP")
			this.ip = spans[i].innerHTML; //元のバージョンではinnerTextだったんですけど、なんかScriptから追加したDOM Elementの中身はinnerHTMLじゃないと取れないみたいです。
		if (spans[i].className == "hostName")
			this.name = spans[i].innerHTML;
	}
	this.commandLine = "/sbin/ping -t " + timeout + " " + this.ip;
}

Scanner.prototype.start = function() {
	LOG__("Scanner.start");
	LOG__("commandLine:" + this.commandLine);

	this.li.style.textDecoration = "underline";

	if(this.command != null)
		this.command.cancel();

	var localThis = this;
	this.command = widget.system(this.commandLine, function(){ localThis.end(); });
	this.command.onreadoutput = function(str){ localThis.read(str); }
}

Scanner.prototype.read = function(str) {
	LOG__("Scanner.read");
	var time, loss;

	if (str.match(/time=([\d\.]+) ms$/)) {
		this.command.cancel();
		time = RegExp.$1 - 0;

		LOG__("time:" + time + "ms");
		this.li.style.textDecoration = "none";
		this.li.setAttribute("title", time + "ms");
		this.li.style.opacity = 1.0;
	}

	if (str.match(/(\d{1,3})% packet loss/)) {
		this.command.cancel();
		loss = RegExp.$1 - 0;

		LOG__("loss:" + loss + "%");
		if (100 <= loss) {
			this.li.style.textDecoration = "none";
			this.li.setAttribute("title", "No connection");
			this.li.style.opacity = 0.15;
		}
	}
}

Scanner.prototype.end = function() {
	LOG__("Scanner.end");
}

//Hostを意味するクラス、って見りゃ解るか
function Host( IP, name ){
	this.IP = IP;
	if(name)
		this.name = name;
}
Host.toStringSplitter = "\t"; //文字列化する時に、この文字でフィールドを区切る。
Host.prototype.toString = function(){
	return this.IP + Host.toStringSplitter + this.name;
}
// Host.toStringで吐き出される形式の文字列からHostを作る。
function createHostFromHostString( hoststring ){
	var vars = hoststring.split(Host.toStringSplitter);
	return new Host(vars[0], vars[1]);
}

// host: Hostオブジェクト
function addHost( host ){
	LOG__("addHost: " + host.toString() );
	hosts.push(host);
	//表面への追加
	var li = document.createElement("li");
	var namespan = document.createElement("span");
	namespan.className = "hostName";
	namespan.innerText = host.name;
	li.appendChild(namespan);
	var ipspan = document.createElement("span");
	ipspan.className = "hostIP";
	ipspan.innerText = host.IP;
	li.appendChild(ipspan);
	document.getElementById("hosts").appendChild(li);
	//scannersへの追加
	scanners.push(new Scanner(scanners.length)); //うぅ、むりやり臭い。
	//裏面のリストへの追加
	var tr = document.createElement("tr");
	var nametd = document.createElement("td");
	nametd.innerText = host.name;
	nametd.className = "nametd"
	var iptd = document.createElement("td");
	iptd.innerText = host.IP;
	iptd.className = "iptd"
	var deltd = document.createElement("td");
	deltd.className = "deltd"
	deltd.innerText = "⏏";
	var fn = function(){ //削除用。かなり力押しorz
		//HTMLからの削除
		document.getElementById("hostsTable").removeChild(tr);
		document.getElementById("hosts").removeChild(li);
		//配列からの削除
		for( h in hosts ){
			if(hosts[h] == host){
				LOG__("remove:"+host);
				hosts.splice(h,1);
				scanners.splice(h,1);
			}
		}
		
	}
	deltd.addEventListener("click", fn, true);
	tr.appendChild(deltd);
	tr.appendChild(nametd);
	tr.appendChild(iptd);
	document.getElementById("hostsTable").appendChild(tr);
}

// 裏面でのHost追加用
//UIからのHost追加
function addNewHost(){
	newhost = new Host(document.newHost.newHostIP.value, document.newHost.newHostName.value);
	addHost(newhost);
}


// ================================================
// Debugging
// ================================================
function LOG__(arg) {
//	alert(arg);
}

